﻿// -----------------------------------------------------------------------
// <copyright file="XamDatagridControl.cs" company="Microsoft">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace BindingIssue.UserControls
{
    using System;
    using Infragistics.Windows;
    using Infragistics.Windows.DataPresenter;
    using System.Windows;
    using System.Windows.Controls;
    using System.Collections.ObjectModel;
    using System.Collections;
    using System.Collections.Generic;
    using Infragistics.Windows.DataPresenter.Events;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class XamDatagridControl : XamDataGrid
    {
        #region Properties

        public static readonly DependencyProperty PreSelectedRecordsProperty =
            DependencyProperty.Register("PreSelectedRecords", typeof(IEnumerable<DataRecord>), typeof(XamDatagridControl),
            new FrameworkPropertyMetadata(null, new PropertyChangedCallback(OnPreSelectedRecordsPropertyChanged)));

        public IEnumerable<DataRecord> PreSelectedRecords
        {
            get { return (IEnumerable<DataRecord>)GetValue(PreSelectedRecordsProperty); }
            set { SetValue(PreSelectedRecordsProperty, value); }
        }

        protected static void OnPreSelectedRecordsPropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            XamDatagridControl myGrid = sender as XamDatagridControl;
            IEnumerable<DataRecord> myRecords = e.NewValue as IEnumerable<DataRecord>;
            List<Record> list = new List<Record>(myRecords);
            myGrid.ActiveRecord = null;

            if (e.NewValue != null && myGrid.Records.Count > 0)
            {
                myGrid.SelectedItems.Records.AddRange(list.ToArray());
            }
        }

        public SelectedRecordCollection SelectedRecords
        {
            get { return (SelectedRecordCollection)GetValue(SelectedRecordsProperty); }
            set { SetValue(SelectedRecordsProperty, value); }
        }

        public static readonly DependencyProperty SelectedRecordsProperty =
           DependencyProperty.Register("SelectedRecords", typeof(SelectedRecordCollection), typeof(XamDatagridControl),
           new FrameworkPropertyMetadata(null));
        
        #endregion

        public XamDatagridControl()
        {
            this.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(AwrdsDataGrid_FieldLayoutInitialized);
            this.SelectedItemsChanged += new EventHandler<Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs>(XamDatagridControl_SelectedItemsChanged);
        }

        void XamDatagridControl_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {
            XamDatagridControl myGrid = sender as XamDatagridControl;
            myGrid.SelectedRecords = myGrid.SelectedItems.Records;            
        }
                 
        void AwrdsDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            XamDataGrid myAWRDSGrid = sender as XamDataGrid;

            UnboundField CheckboxField = new UnboundField()
            {
                Name = "checkbox",
                Label = string.Empty,
                Width = FieldLength.Auto,
                FixedLocation = FixedFieldLocation.FixedToNearEdge
            };

            CheckboxField.Settings.AllowFixing = AllowFieldFixing.No;
            CheckboxField.Settings.AllowHiding = AllowFieldHiding.Never;
            CheckboxField.Settings.AllowRecordFiltering = false;
            CheckboxField.Settings.AllowResize = false;
            CheckboxField.Settings.LabelClickAction = LabelClickAction.Nothing;
            CheckboxField.Settings.CellValuePresenterStyle = (Style)myAWRDSGrid.TryFindResource("ShowInChartCellStyle");
            e.FieldLayout.Fields.Insert(0, CheckboxField);
            e.FieldLayout.Settings.FixedFieldUIType = FixedFieldUIType.None;
        }
        
    }
}
