﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using System.Collections;

namespace BindingIssue.View
{
    /// <summary>
    /// Interaction logic for Main.xaml
    /// </summary>
    public partial class Main : Page, INotifyPropertyChanged
    {
        public Main()
        {
            InitializeComponent();
            this.DataContext = this;    
        }

        private List<Person> persons;
        public List<Person> Persons
        {
            get { return persons; }
            set
            {
                persons = value;
                this.OnPropertyChanged("Persons");
            }
        }

        private SelectedRecordCollection selectedPersons;
        public SelectedRecordCollection SelectedPersons
        {
            get { return selectedPersons; }
            set
            {
                selectedPersons = value;
                OnPropertyChanged("SelectedPersons");
            }
        }

        private IEnumerable<DataRecord> preSelectRecords;
        public IEnumerable<DataRecord> PreSelectRecords
        {
            get { return preSelectRecords; }
            set { preSelectRecords = value; OnPropertyChanged("PreSelectRecords"); }
        }

        private void GetData()
        {
            List<Person> myPersons = new List<Person>();
            myPersons.Add(new Person { Name = "Joe Smith", Title = "VP", IsManager = true, Level = 3, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(1)) });
            myPersons.Add(new Person { Name = "Tom Jones", Title = "Team Leader", IsManager = true, Level = 2, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(2)) });
            myPersons.Add(new Person { Name = "Bill Bailey", Title = "Salesperson", IsManager = false, Level = 1, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(3)) });
            myPersons.Add(new Person { Name = "John Doe", Title = "Specialist", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(4)) });
            myPersons.Add(new Person { Name = "Jolene Jones", Title = "Writer", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(5)) });
            myPersons.Add(new Person { Name = "John Doroski", Title = "Accountant", IsManager = false, Level = 2, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(6)) });
            myPersons.Add(new Person { Name = "Billiam Clark", Title = "Manager", IsManager = true, Level = 3, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(7)) });
            myPersons.Add(new Person { Name = "Tomas Lundstrom", Title = "Furrier", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(8)) });
            myPersons.Add(new Person { Name = "Harry Carey", Title = "Plumber", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(9)) });
            myPersons.Add(new Person { Name = "Harry Carson", Title = "Glazier", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(10)) });
            myPersons.Add(new Person { Name = "Happy Rockefeller", Title = "Roofer", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(11)) });
            myPersons.Add(new Person { Name = "John Salesman", Title = "Salesman", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(12)) });
            myPersons.Add(new Person { Name = "Billiam Clarkson", Title = "Manager", IsManager = true, Level = 3, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(7)) });
            myPersons.Add(new Person { Name = "Tomas Lundstroms", Title = "Furrier", IsManager = true, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(8)) });
            myPersons.Add(new Person { Name = "Harry Carrey", Title = "Plumber", IsManager = false, Level = 3, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(9)) });
            myPersons.Add(new Person { Name = "Henry Carson", Title = "Glazier", IsManager = true, Level = 1, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(10)) });
            myPersons.Add(new Person { Name = "Saddness Rockefeller", Title = "Roofer", IsManager = false, Level = 1, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(11)) });
            myPersons.Add(new Person { Name = "Joshua Salesman", Title = "Salesman", IsManager = false, Level = 2, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(12)) });
                        
            Persons = myPersons;

            this.OnPropertyChanged("Persons");
        }

        private void GetSelectedData()
        {
            PreSelectRecords = SelectedPersons.Cast<DataRecord>();
        }

        public class Person
        {
            public Person()
            {
                
            }

            public string Name { get; set; }
            public string Title { get; set; }
            public int Level { get; set; }
            public bool IsManager { get; set; }
            public DateTime HireDate { get; set; }            
        }

        #region PropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        #endregion

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            GetData();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            GetSelectedData();
        }
    }

    
}
